stages:
    - build
    - test
    - review
    - deploy

variables:
  DOCKER_HOST: tcp://docker:2375
  MOUNT_POINT: "/builds/$CI_PROJECT_PATH/mnt"
  NAMESPACE: store-review
  IMAGE_TAG: "$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA"
  PRODUCTION_IMAGE: "$CI_REGISTRY_IMAGE/$CI_COMMIT_SHORT_SHA:latest"

include:
  - template: Jobs/Dependency-Scanning.latest.gitlab-ci.yml
  - template: Jobs/SAST.latest.gitlab-ci.yml
  - template: Jobs/Secret-Detection.gitlab-ci.yml
  - template: Code-Quality.gitlab-ci.yml

build:
  tags: [ saas-linux-large-amd64 ]
  image: docker:20.10.16
  stage: build
  services:
    - docker:20.10.16-dind
  
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_TAG .
    - docker push $IMAGE_TAG

  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event" 
      when: always
      
unit-testing:
    image: python:3.8
    before_script:
      - pip install pytest==7.4.4
    script:
      - echo "testing" 

    rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event" 
      when: always


store_review_env:
  tags: [ saas-linux-large-amd64 ]
  image: crileroro/gcloud-kubectl-helm
  stage: review
  script:
    - kubectl config use-context $KUBE_CONTEXT
    - kubectl create ns $NAMESPACE-$CI_ENVIRONMENT_SLUG --dry-run=client -o yaml | kubectl apply -f -
    - helm upgrade -i review-$CI_COMMIT_SHORT_SHA review-charts --namespace $NAMESPACE-$CI_ENVIRONMENT_SLUG --set ingress.host=$CI_ENVIRONMENT_SLUG.$INGRESS --set image.repository=$IMAGE_TAG

  environment:
    name: review/$CI_COMMIT_REF_NAME/$CI_PIPELINE_IID
    url: https://$CI_ENVIRONMENT_SLUG.$INGRESS


  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event" 



build-prod-image:
  tags: [ saas-linux-large-amd64 ]
  image: docker:20.10.16
  stage: build
  services:
    - docker:20.10.16-dind
  
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $PRODUCTION_IMAGE .
    - docker push $PRODUCTION_IMAGE
    - echo "UPSTREAM_CONTAINER_IMAGE=$PRODUCTION_IMAGE" >> prodimage.env

  artifacts:
    reports:
      dotenv: prodimage.env

  rules:
     - if: '$CI_COMMIT_BRANCH == "main"'
       when: always
     - when: never


trigger-manifest-update:
  stage: deploy
  inherit:
    variables: false
  trigger: gitlab-da/use-cases/devsecops-platform/simply-find/simply-find-manifests
  rules:
    - if: '$CI_COMMIT_BRANCH == "main"'
      when: always
    - when: never


.build-mr:
  stage: build
  script:
    - echo "build in mr"
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"

.review-mr:
  stage: review
  script:
    - echo "review in mr"
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: always

.build-prod:
  stage: build
  script:
    - echo "build prod"
  rules:
     - if: '$CI_COMMIT_BRANCH == "main"'
       when: always
     - when: never

.deploy:
  stage: deploy
  script:
    - echo "deploy"
  rules:
     - if: '$CI_COMMIT_BRANCH == "main"'
       when: always
     - when: never


